﻿/****************************************************************
 * @class CommsPage
 * 
 * @author Tommy Omen
 * 
 * Allows user to play voice communication
 * 
 ***************************************************************/
using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using PowerDroid.TextToSpeech;
using System.IO.IsolatedStorage;
using System.IO;
using Microsoft.Phone.Tasks;

namespace PowerDroid
{
    public partial class CommsPage : PhoneApplicationPage
    {

        List<String> m_playList = new List<String>();
        String m_userName = "Tommy";
        String m_hackText = "";

        public CommsPage()
        {
            InitializeComponent();
        }

        void client_SpeakCompleted(object sender, SpeakCompletedEventArgs e)
        {
			if(e.Error != null)
			{
				System.Console.Write(e.Error);
				return;
			}

            WebClient wc = new WebClient();
            wc.OpenReadCompleted += WcOpenReadCompleted;
            wc.OpenReadAsync(new Uri(e.Result, UriKind.Absolute));
        }

        void WcOpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            m_textToSpeechMediaElement.Source = null;
            string filename = "test";
            using (IsolatedStorageFile userStoreForApplication = IsolatedStorageFile.GetUserStoreForApplication())
            {
                bool fileExists = userStoreForApplication.FileExists(filename);

                if (fileExists)
                {
                    userStoreForApplication.DeleteFile(filename);
                }

                var isolatedStorageFileStream = userStoreForApplication.CreateFile(filename);

                using (isolatedStorageFileStream)
                {
                    CopyStream(e.Result, isolatedStorageFileStream);

                    if (e.Error == null)
                    {
                        m_textToSpeechMediaElement.SetSource(isolatedStorageFileStream);
                        m_textToSpeechMediaElement.Play();

                    }
                }
            }
        }

        public static void CopyStream(Stream input, Stream output)
        {
            byte[] buffer = new byte[32768];
            while (true)
            {
                int read = input.Read(buffer, 0, buffer.Length);
                if (read <= 0)
                {
                    return;
                }
                output.Write(buffer, 0, read);
            }
        }

        //OMGZ this is hack
        public void AddNewBtn(Button btn, String text)
        {
            m_hackBtn.Background = btn.Background;
            m_hackText = text;
            
            //set button size to whatever every other btn is set too
            m_hackBtn.Width = m_pleaseBtn.Width;
            m_hackBtn.Height = m_pleaseBtn.Height;

            m_hackBtn.Visibility = Visibility.Visible;
        }

        private void m_homeBtn_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/HomePage.xaml", UriKind.Relative));
        }

        private void m_helloBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("Hello");
        }

        private void playAndQueueCommsBtn(String str)
        {
            LanguageServiceClient client = new LanguageServiceClient();
            client.SpeakCompleted += client_SpeakCompleted;
            client.SpeakAsync("A05A61388A448F55C9628C941FB2FC459D697060", str, "en", string.Empty);
            if (m_sentTB.Text.Equals("<No Sentence>"))
            {
                m_sentTB.Text = "";
            }

            m_sentTB.Text += str + " ";

            m_playList.Add(str);
        }

        private void m_playVoice_Click(object sender, RoutedEventArgs e)
        {
            String playStr = "";
            foreach (String word in m_playList)
            {
                playStr += word;
            }

            if (!playStr.Equals(""))
            {
                LanguageServiceClient client = new LanguageServiceClient();
                client.SpeakCompleted += client_SpeakCompleted;
                client.SpeakAsync("A05A61388A448F55C9628C941FB2FC459D697060", playStr, "en", string.Empty);
            }
        }

        private void m_goodbyeBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("Goodbye");
        }

        private void m_howRUBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("How Are You");
        }

        private void m_myNameBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("My Name Is " + m_userName );
        }

        private void m_yesBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("Yes");
        }

        private void m_noBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("No");
        }

        private void m_maybeBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("Maybe");
        }

        private void m_pleaseBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("Please");
        }

        private void m_urWelcomeBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("You Are Welcome");
        }

        private void m_thankUBtn_Click(object sender, RoutedEventArgs e)
        {
            playAndQueueCommsBtn("Thank you");
        }

        private void m_hackBtn_Click(object sender, RoutedEventArgs e)
        {
            if (m_hackText.Equals(""))
            {
                return;
            }

            playAndQueueCommsBtn(m_hackText);
        }

        private void m_clearBtn_Click(object sender, RoutedEventArgs e)
        {
            m_playList.Clear();
            m_sentTB.Text = "<No Sentence>";
        }

        private void m_emergencyBtn_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/EmergencyPage.xaml", UriKind.Relative));
        }

        private void m_searchBtn_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/SearchPage.xaml", UriKind.Relative));
        }

        private void m_helpBtn_Click(object sender, RoutedEventArgs e)
        {
            WebBrowserTask wbt = new WebBrowserTask();
            wbt.URL = "http://www.utdallas.edu/~jxg042000/resources/documents/The%20Official%20HOPE%20User%20Manual%20v1.0(first%20draft).docx";
            wbt.Show();
        }

        private void m_plusBtn_Click(object sender, RoutedEventArgs e)
        {
            //pass a reference of myself to the next page by using global Application.Current.RootVisual
            FrameworkElement root = Application.Current.RootVisual as FrameworkElement;
            root.DataContext = this;

            NavigationService.Navigate(new Uri("/CustomizationPage.xaml", UriKind.Relative));


        }

    } //end of class
} //end of namespace