﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.IO;
using PowerDroid.TextToSpeech;
using System.IO.IsolatedStorage;

namespace PowerDroid
{
    public partial class DailyActivitiesPage2 : PhoneApplicationPage
    {
        private LanguageServiceClient LanguageClient = new LanguageServiceClient();
        private WebClient WClient = new WebClient();

        public DailyActivitiesPage2()
        {
            InitializeComponent();
            powerAppBar1.parent = this;

            LanguageClient.SpeakCompleted += SpeakCompleted;
            WClient.OpenReadCompleted += WCOpenReadCompleted;
            
        }

        void SpeakCompleted(object sender, SpeakCompletedEventArgs e)
        {
            if (e.Error != null)
                return;

            WClient.OpenReadAsync(new Uri(e.Result, UriKind.Absolute));
        }
        void WCOpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            TextToSpeechMediaElement.Source = null;
            string temp = "tempTextToSpeech";
            using (IsolatedStorageFile userStoreForApplication = IsolatedStorageFile.GetUserStoreForApplication())
            {
                if (userStoreForApplication.FileExists(temp))
                    userStoreForApplication.DeleteFile(temp);

                var storageFileStream = userStoreForApplication.CreateFile(temp);

                using (storageFileStream)
                {
                    CopyStream(e.Result, storageFileStream);
                    if (e.Error == null)
                    {
                        TextToSpeechMediaElement.SetSource(storageFileStream);
                        TextToSpeechMediaElement.Play();
                    }
                }
            }
        }
        private void CopyStream(Stream input, Stream output)
        {
            byte[] buffer = new byte[32768];
            while (true)
            {
                int read = input.Read(buffer, 0, buffer.Length);
                if (read <= 0)
                    return;
                output.Write(buffer, 0, buffer.Length);
            }
        }
        private void PlaySentence1Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(FirstFavTextBlock.Text);
        }

        private void PlaySentence2Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(m_secondTask.Text);
        }

        private void PlaySentence3Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(m_thirdTask.Text);
        }

        private void PlaySentence4Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(m_fourthTask.Text);
        }

        private void PlaySentence5Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(m_fifthTask.Text);
        }

        private void PlaySentence(string sentence)
        {
            LanguageClient.SpeakAsync("A05A61388A448F55C9628C941FB2FC459D697060", sentence, "en", String.Empty);
        }

        private void NewSentence_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/DailyActivityNewTask.xaml", UriKind.Relative));
        }

        private void PhoneApplicationPage_GotFocus(object sender, RoutedEventArgs e)
        {

        }

        private void PhoneApplicationPage_BackKeyPress(object sender, System.ComponentModel.CancelEventArgs e)
        {

        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            switch ((Application.Current as App).TASK_DESC_COUNT)
            {
                case 2: this.m_secondTask.Text = (Application.Current as App).TASK_DESC;
                    this.SecondFavGrid.Visibility = Visibility.Visible;
                    break;
                case 3: this.m_thirdTask.Text = (Application.Current as App).TASK_DESC;
                    this.ThirdFavGrid.Visibility = Visibility.Visible;
                    break;
                case 4: this.m_fourthTask.Text = (Application.Current as App).TASK_DESC;
                    this.FourthFavGrid.Visibility = Visibility.Visible;
                    break;
                case 5: this.m_fifthTask.Text = (Application.Current as App).TASK_DESC;
                    this.FifthFavGrid.Visibility = Visibility.Visible;
                    break;
                default:
                    break;
            }
        }

        private void DeleteSentence1Button_Click(object sender, RoutedEventArgs e)
        {
            this.FirstFavTextBlock.Text = "";
            this.FirstFavGrid.Visibility = Visibility.Collapsed;
        }

        private void DeleteSentence2Button_Click(object sender, RoutedEventArgs e)
        {
            this.m_secondTask.Text = "";
            this.SecondFavGrid.Visibility = Visibility.Collapsed;
        }

        private void DeleteSentence3Button_Click(object sender, RoutedEventArgs e)
        {
            this.m_thirdTask.Text = "";
            this.ThirdFavGrid.Visibility = Visibility.Collapsed;
        }

        private void DeleteSentence4Button_Click(object sender, RoutedEventArgs e)
        {
            this.m_fourthTask.Text = "";
            this.FourthFavGrid.Visibility = Visibility.Collapsed;
        }

        private void DeleteSentence5Button_Click(object sender, RoutedEventArgs e)
        {
            this.m_fifthTask.Text = "";
            this.FifthFavGrid.Visibility = Visibility.Collapsed;
        }


    }
}