﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Markup;
using System.Windows.Interop;
using Microsoft.Phone.Tasks;

namespace PowerDroid
{
    public partial class EmergencyPage3 : PhoneApplicationPage
    {
        public EmergencyPage3()
        {
            InitializeComponent();
            List<PivotData> data = new List<PivotData>();
            data.Add(new PivotData() { ImageUri = new Uri("Images/emergency_v2.png", UriKind.Relative) ,
                                       PivotName = "Emergency",
                                       PivotContent = CreateEmergencyPivotPage()
            });
            data.Add(new PivotData() { ImageUri = new Uri("Images/contact_small.png", UriKind.Relative), 
                                        PivotName = "Contacts",
                                       PivotContent = new Grid()
            });
            this.m_pivoter.ItemsSource = data;

            this.m_pivoter.LoadedPivotItem += Pivot_LoadedPivotItem;

			// Tommy, when you add the PowerAppBar to this page, uncomment the following lines:
			// powerAppBar1.parent = this;
			// powerAppBar1.ParentIsEmergencyPage = true;
        }

        private Grid CreateEmergencyPivotPage()
        {
            string strTemplate = @"<Grid xmlns=""http://schemas.microsoft.com/winfx/2006/xaml/presentation""
                        xmlns:x=""http://schemas.microsoft.com/winfx/2006/xaml"" x:Name=""ContentPanel3"" Grid.Row=""1"" Margin=""5,0,5,0"">
                <Grid Height=""487"" HorizontalAlignment=""Left"" Margin=""0,0,-10,0"" Name=""grid9"" VerticalAlignment=""Top"" Width=""456"">
                    <Grid.ColumnDefinitions>
                        <ColumnDefinition Width=""177*"" />
                        <ColumnDefinition Width=""279*"" />
                    </Grid.ColumnDefinitions>
                    <Grid.RowDefinitions>
                        <RowDefinition Height=""37*"" />
                        <RowDefinition Height=""450*"" />
                    </Grid.RowDefinitions>
                    <Button Grid.RowSpan=""2"" Height=""160"" HorizontalAlignment=""Left"" Margin=""-2,29,0,0"" Name=""m_call911Btn"" VerticalAlignment=""Top"" Width=""160"" BorderBrush=""{x:Null}"">
                        <Button.Background>
                             <ImageBrush ImageSource=""/PowerDroid;component/Images/911.png"" />
                        </Button.Background>                    
                    </Button>
                    <Button Grid.Row=""1"" Height=""160"" HorizontalAlignment=""Left"" Margin=""-1,199,0,0"" Name=""m_callDrBtn"" VerticalAlignment=""Top"" Width=""160"" BorderBrush=""{x:Null}"">
                        <Button.Background>
                             <ImageBrush ImageSource=""/PowerDroid;component/Images/doctor.png"" />
                        </Button.Background>                    
                    </Button>
                    <Button Grid.ColumnSpan=""2"" Grid.RowSpan=""2"" Height=""160"" HorizontalAlignment=""Left"" Margin=""150,28,0,0"" Name=""m_callAsstBtn"" VerticalAlignment=""Top"" Width=""160"" BorderBrush=""{x:Null}"" >
                        <Button.Background>
                             <ImageBrush ImageSource=""/PowerDroid;component/Images/assistant.png"" />
                        </Button.Background>                    
                    </Button>
                    <Button Grid.Column=""1"" Grid.RowSpan=""2"" Height=""160"" HorizontalAlignment=""Left"" Margin=""123,29,0,0"" Name=""m_txt911Btn"" VerticalAlignment=""Top"" Width=""160"" BorderBrush=""{x:Null}"" >
                        <Button.Background>
                             <ImageBrush ImageSource=""/PowerDroid;component/Images/911.png"" />
                        </Button.Background>                    
                    </Button>
                    <Button Grid.ColumnSpan=""2"" Grid.Row=""1"" Height=""160"" HorizontalAlignment=""Left"" Margin=""150,199,0,0"" Name=""m_txtDrBtn"" VerticalAlignment=""Top"" Width=""160"" BorderBrush=""{x:Null}"" >
                        <Button.Background>
                             <ImageBrush ImageSource=""/PowerDroid;component/Images/doctor.png"" />
                        </Button.Background>                    
                    </Button>
                    <Button Grid.Column=""1"" Grid.Row=""1"" Height=""160"" HorizontalAlignment=""Left"" Margin=""123,198,0,0"" Name=""m_txtAsstBtn"" VerticalAlignment=""Top"" Width=""160"" BorderBrush=""{x:Null}"" >
                        <Button.Background>
                             <ImageBrush ImageSource=""/PowerDroid;component/Images/assistant.png"" />
                        </Button.Background>                    
                    </Button>                    
                    <TextBlock Grid.Row=""1"" Height=""30"" HorizontalAlignment=""Left"" Margin=""39,146,0,0"" Name=""m_call911Lbl"" Text=""Call 911"" VerticalAlignment=""Top"" />
                    <TextBlock Grid.Column=""1"" Grid.Row=""1"" Height=""30"" HorizontalAlignment=""Left"" Margin=""12,142,0,0"" Name=""m_callDrLbl"" Text=""Call Doctor"" VerticalAlignment=""Top"" />
                    <TextBlock Grid.Column=""1"" Grid.Row=""1"" Height=""30"" HorizontalAlignment=""Left"" Margin=""159,142,0,0"" Name=""m_callAsstLbl"" Text=""Call Assistant"" VerticalAlignment=""Top"" />
                    <TextBlock Grid.Row=""1"" Height=""30"" HorizontalAlignment=""Left"" Margin=""34,356,0,0"" Name=""m_txt911Lbl"" Text=""Text 911"" VerticalAlignment=""Top"" />
                    <TextBlock Grid.Column=""1"" Grid.Row=""1"" Height=""30"" HorizontalAlignment=""Left"" Margin=""6,355,0,0"" Name=""m_txtDrLbl"" Text=""Text Doctor"" VerticalAlignment=""Top"" />
                    <TextBlock Grid.Column=""1"" Grid.Row=""1"" Height=""30"" HorizontalAlignment=""Left"" Margin=""157,353,0,0"" Name=""m_txtAsstLbl"" Text=""Text Assistant"" VerticalAlignment=""Top"" />
                </Grid>
                <Button BorderBrush=""{x:Null}"" Height=""120"" HorizontalAlignment=""Right"" Margin=""0,0,210,-8"" Name=""m_homeBtn"" VerticalAlignment=""Bottom"" Width=""120"">
                    <Button.Background>
                        <ImageBrush ImageSource=""/PowerDroid;component/Images/home.png"" />
                    </Button.Background>
                </Button>
                <Button BorderBrush=""{x:Null}"" Height=""120"" Margin=""0,495,312,-8"" Name=""m_searchBtn"" Width=""120"">
                    <Button.Background>
                        <ImageBrush ImageSource=""/PowerDroid;component/Images/search.png"" />
                    </Button.Background>
                </Button>
                <Button BorderBrush=""{x:Null}"" Height=""120"" HorizontalAlignment=""Left"" Margin=""330,495,0,-8"" Name=""m_helpBtn"" VerticalAlignment=""Top"" Width=""120"">
                    <Button.Background>
                        <ImageBrush ImageSource=""/PowerDroid;component/Images/help.png"" />
                    </Button.Background>
                </Button>
                <Button BorderBrush=""{x:Null}"" Height=""120"" HorizontalAlignment=""Right"" Margin=""0,495,107,-8"" Name=""m_emergencyBtn2"" Width=""120"">
                    <Button.Background>
                        <ImageBrush ImageSource=""/PowerDroid;component/Images/emergency_v2.png"" />
                    </Button.Background>
                </Button>
            </Grid>";
            Grid g = (Grid)XamlReader.Load( strTemplate );
            //can't set event handlers statically in XAML must do it using this hackish method. 
            foreach (UIElement uie in g.Children)
            {
                if (uie is Button)
                {
                    Button btn = (Button)uie;
                    if (btn.Name.Equals("m_homeBtn"))
                    {
                        btn.Click += m_homeBtn_Click;
                    }
                    else if (btn.Name.Equals("m_helpBtn"))
                    {
                        btn.Click += m_helpBtn_Click;
                    }
                    else if (btn.Name.Equals("m_searchBtn"))
                    {
                        btn.Click += m_searchBtn_Click;
                    }

                }
                else if (uie is Grid)
                {
                    Grid g2 = (Grid)uie;
                    foreach (UIElement uie2 in g2.Children)
                    {
                        if (uie2 is Button)
                        {
                            Button btn = (Button)uie2;
                            if (btn.Name.Equals("m_txtAsstBtn"))
                            {
                                btn.Click += m_txtAssistantBtn_Click;
                            }
                            else if (btn.Name.Equals("m_txtDrBtn"))
                            {
                                btn.Click += m_txtDrBtn_Click;
                            }
                            else if (btn.Name.Equals("m_txt911Btn"))
                            {
                                btn.Click += m_txt911Btn_Click;
                            }
                            else if (btn.Name.Equals("m_callAsstBtn"))
                            {
                                btn.Click += m_callAssistantBtn_Click;
                            }
                            else if (btn.Name.Equals("m_callDrBtn"))
                            {
                                btn.Click += m_callDrBtn_Click;
                            }
                            else if (btn.Name.Equals("m_call911Btn"))
                            {
                                btn.Click += m_911Btn_Click;
                            }
                        }
                    }
                }

            }


            return g;
        }


        private void m_homeBtn_Click(object sender, RoutedEventArgs e)
        {
            //TODO why causes exception?
            NavigationService.Navigate(new Uri("/HomePage.xaml", UriKind.Relative));
        }

        private void m_searchBtn_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/SearchPage.xaml", UriKind.Relative));
        }

        private void m_helpBtn_Click(object sender, RoutedEventArgs e)
        {
            WebBrowserTask wbt = new WebBrowserTask();
            wbt.URL = "http://www.utdallas.edu/~jxg042000/resources/documents/The%20Official%20HOPE%20User%20Manual%20v1.0(first%20draft).docx";
            wbt.Show();
        }

        private void m_commsBtn_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/CommunicationPage.xaml", UriKind.Relative));
        }

        private void m_emergencyBtn_Click(object sender, RoutedEventArgs e)
        {
            //Do nothing
        }

        private void m_911Btn_Click(object sender, RoutedEventArgs e)
        {
            PhoneCallTask call = new PhoneCallTask();
            call.DisplayName = "Emergency Hotline";
            call.PhoneNumber = "9911";
            call.Show();
        }

        private void m_txtDrBtn_Click(object sender, RoutedEventArgs e)
        {
            SmsComposeTask smsComposeTask = new SmsComposeTask();
            smsComposeTask.To = "Dr. Phil";
            smsComposeTask.Body = "Help I'm Hurt!!";
            smsComposeTask.Show();
        }

        private void m_txt911Btn_Click(object sender, RoutedEventArgs e)
        {
            SmsComposeTask smsComposeTask = new SmsComposeTask();
            smsComposeTask.To = "9911";
            smsComposeTask.Body = "Help I'm Hurt!!";
            smsComposeTask.Show();
        }

        private void m_callDrBtn_Click(object sender, RoutedEventArgs e)
        {
            PhoneCallTask call = new PhoneCallTask();
            call.DisplayName = "Dr. Phil";
            call.PhoneNumber = "123-456-7890";
            call.Show();
        }

        private void m_homeBtn_Click_1(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/HomePage.xaml", UriKind.Relative));
        }

        private void m_txtAssistantBtn_Click(object sender, RoutedEventArgs e)
        {
            SmsComposeTask smsComposeTask = new SmsComposeTask();
            smsComposeTask.To = "Richard Harris";
            smsComposeTask.Body = "Help I'm Hurt!!";
            smsComposeTask.Show();
        }

        private void m_callAssistantBtn_Click(object sender, RoutedEventArgs e)
        {
            PhoneCallTask call = new PhoneCallTask();
            call.DisplayName = "Richard Harris";
            call.PhoneNumber = "123-456-7890";
            call.Show();
        }

        private void Pivot_LoadedPivotItem(object sender, PivotItemEventArgs e)
        {
            PivotData pd = e.Item.Content as PivotData;
            if ( pd.PivotName.Equals("Contacts") )
            {
                NavigationService.Navigate(new Uri("/EnrichedContactsPage.xaml", UriKind.Relative));
            }
        }

    }

    public class PivotData
    {
        public Uri ImageUri
        {
            get;
            set;
        }

        public String PivotName
        {
            get;
            set;
        }

        public Grid PivotContent
        {
            get;
            set;
        }
    }
}