﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.IO.IsolatedStorage;
using PowerDroid.TextToSpeech;
using System.IO;

namespace PowerDroid
{
    public partial class EnrichedContactsPage : PhoneApplicationPage
    {
        private LanguageServiceClient LanguageClient = new LanguageServiceClient();
        private WebClient WClient = new WebClient();
        private String[] m_phoneNums = new String[4];

        public EnrichedContactsPage()
        {
            InitializeComponent();
            powerAppBar1.parent = this;

            LanguageClient.SpeakCompleted += SpeakCompleted;
            WClient.OpenReadCompleted += WCOpenReadCompleted;

            m_phoneNums[0] = "972-233-2120";
            m_phoneNums[1] = "469-672-1230";
            m_phoneNums[2] = "214-135-1999";
            m_phoneNums[3] = "972-664-2983";
        }

        void SpeakCompleted(object sender, SpeakCompletedEventArgs e)
        {
            if (e.Error != null)
                return;

            WClient.OpenReadAsync(new Uri(e.Result, UriKind.Absolute));
        }
        void WCOpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            TextToSpeechMediaElement.Source = null;
            string temp = "tempTextToSpeech";
            using (IsolatedStorageFile userStoreForApplication = IsolatedStorageFile.GetUserStoreForApplication())
            {
                if (userStoreForApplication.FileExists(temp))
                    userStoreForApplication.DeleteFile(temp);

                var storageFileStream = userStoreForApplication.CreateFile(temp);

                using (storageFileStream)
                {
                    CopyStream(e.Result, storageFileStream);
                    if (e.Error == null)
                    {
                        TextToSpeechMediaElement.SetSource(storageFileStream);
                        TextToSpeechMediaElement.Play();
                    }
                }
            }
        }
        private void CopyStream(Stream input, Stream output)
        {
            byte[] buffer = new byte[32768];
            while (true)
            {
                int read = input.Read(buffer, 0, buffer.Length);
                if (read <= 0)
                    return;
                output.Write(buffer, 0, buffer.Length);
            }
        }

        private void PlaySentence(string sentence)
        {
            LanguageClient.SpeakAsync("A05A61388A448F55C9628C941FB2FC459D697060", sentence, "en", String.Empty);
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {

        }

        private void SpeakFam1Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence( FirstFamTextBlock.Text );
        }

        private void SpeakFam2Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(SecondFamTextBlock.Text);
        }

        private void SpeakFam3Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(ThirdFamTextBlock.Text);
        }

        private void SpeakFam4Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(FourthFamTextBlock.Text);
        }

        private void FamContact1Button_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            App globalApp = (Application.Current as App);
            globalApp.CONTACT_IMG = b.Background;
            globalApp.CONTACT_NAME = FirstFamTextBlock.Text;
            globalApp.CONTACT_NUMBER = m_phoneNums[0];

            NavigationService.Navigate(new Uri("/EnrichedContactsDetailPage.xaml", UriKind.Relative));
        }

        private void FamContact2Button_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            App globalApp = (Application.Current as App);
            globalApp.CONTACT_IMG = b.Background;
            globalApp.CONTACT_NAME = SecondFamTextBlock.Text;
            globalApp.CONTACT_NUMBER = m_phoneNums[1];

            NavigationService.Navigate(new Uri("/EnrichedContactsDetailPage.xaml", UriKind.Relative));
        }

        private void FamContact3Button_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            App globalApp = (Application.Current as App);
            globalApp.CONTACT_IMG = b.Background;
            globalApp.CONTACT_NAME = ThirdFamTextBlock.Text;
            globalApp.CONTACT_NUMBER = m_phoneNums[2];

            NavigationService.Navigate(new Uri("/EnrichedContactsDetailPage.xaml", UriKind.Relative));
        }

        private void FamContact4Button_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            App globalApp = (Application.Current as App);
            globalApp.CONTACT_IMG = b.Background;
            globalApp.CONTACT_NAME = FourthFamTextBlock.Text;
            globalApp.CONTACT_NUMBER = m_phoneNums[3];

            NavigationService.Navigate(new Uri("/EnrichedContactsDetailPage.xaml", UriKind.Relative));
        }

        private void SpeakAsst1Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(FirstAsstTextBlock.Text);
        }

        private void SpeakFriend1Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(FirstFriendTextBlock.Text);
        }

        private void SpeakFriend2Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(SecondFriendTextBlock.Text);
        }

        private void SpeakFriend3Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(ThirdFriendTextBlock.Text);
        }

        private void SpeakFriend4Button_Click(object sender, RoutedEventArgs e)
        {
            PlaySentence(FourthFriendTextBlock.Text);
        }
    }
}