﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Windows.Shapes;
using System.Windows.Navigation;

namespace PowerDroid
{
	public partial class PowerAppBar : UserControl
	{
		public PhoneApplicationPage parent { get; set; }
		public bool ParentIsHomePage { get; set; }
		public bool ParentIsEmergencyPage { get; set; }
		public bool ParentIsSeachPage { get; set; }
		public PowerAppBar()
		{
			InitializeComponent();
			parent = null;
			ParentIsHomePage = false;
			ParentIsEmergencyPage = false;
			ParentIsSeachPage = false;
		}

		private void EmergencyButtonClick(object sender, RoutedEventArgs e)
		{
			if(parent == null || ParentIsEmergencyPage) return;
			parent.NavigationService.Navigate(new Uri("/EmergencyPage4.xaml", UriKind.Relative));
		}

		private void HomeButtonClick(object sender, RoutedEventArgs e)
		{
			if(parent == null || ParentIsHomePage) return;
            if ((Application.Current as App).assistantViewEnabled)
            {
                parent.NavigationService.Navigate(new Uri("/AssistantViewPage.xaml", UriKind.Relative));
            }
            else
            {
                parent.NavigationService.Navigate(new Uri("/HomePage.xaml", UriKind.Relative));
            }
		}

		private void SearchButtonClick(object sender, RoutedEventArgs e)
		{
			if(parent == null || ParentIsSeachPage) return;
			parent.NavigationService.Navigate(new Uri("/SearchPage.xaml", UriKind.Relative));
		}

		private void HelpButtonClick(object sender, RoutedEventArgs e)
		{
			WebBrowserTask wbt = new WebBrowserTask();
			wbt.URL = "http://www.utdallas.edu/~jxg042000/resources/documents/The%20Official%20HOPE%20User%20Manual%20v1.0(first%20draft).docx";
			wbt.Show();
		}
	}
}
