﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Markup;
using System.Windows.Shapes;
using PowerDroid.TextToSpeech;
using System.IO.IsolatedStorage;
using System.IO;
using Microsoft.Phone.Controls;

namespace PowerDroid
{
    public partial class SettingsPage : PhoneApplicationPage
    {
        private const int SZ_100_100 = 0;
        private const int SZ_120_120 = 1;
        private const int SZ_140_140 = 2;
        private const int SZ_160_160 = 3;

        public Boolean audioViewEnabled = false;

        private bool m_isInited = false;
        //keep these static
        private static int m_iconSize = 160;
        private static int m_fontSize = 20;
        private static String m_userName = "Tommy";

        public SettingsPage()
        {
            InitializeComponent();
            powerAppBar1.parent = this;
            if ((Application.Current as App).assistantViewEnabled)
            {
                m_assistantDisabledBtn.Visibility = System.Windows.Visibility.Collapsed;
            }
            else
            {
                m_assistantDisabledBtn.Visibility = System.Windows.Visibility.Visible;
            }
            m_isInited = true;
        }

        public static int getFontSize()
        {
            return m_fontSize;
        }

        public static int getIconSize()
        {
            return m_iconSize;
        }

        public static String getUserName()
        {
            return m_userName;
        }

        private void m_sizeSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (m_isInited)
            {
                m_previewText.FontSize = m_sizeSlider.Value;
                m_fontSize = (int)m_sizeSlider.Value;
            }
        }

        private void m_iconSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (m_isInited)
            {
                int newSize = -1;
                switch( (int)m_iconSlider.Value )
                {
                    default:
                    case SZ_100_100: newSize = 100; break;
                    case SZ_120_120: newSize = 120; break;
                    case SZ_140_140: newSize = 140; break;
                    case SZ_160_160: newSize = 160; break;
                }
                cat.Width = newSize;
                cat.Height = newSize;
                m_iconSize = newSize;
            }
        }

        private void m_audioBtn_Click(object sender, RoutedEventArgs e)
        {
            if (audioViewEnabled)
            {
                audioViewEnabled = false;
                m_audioDisabledBtn.Visibility = System.Windows.Visibility.Collapsed;
            }
            else
            {
                audioViewEnabled = true;
                m_audioDisabledBtn.Visibility = System.Windows.Visibility.Visible;
            }
        }

        private void m_assistantBtn_Click(object sender, RoutedEventArgs e)
        {
            (Application.Current as App).assistantViewEnabled = !(Application.Current as App).assistantViewEnabled;
            if ((Application.Current as App).assistantViewEnabled)
            {
                m_assistantDisabledBtn.Visibility = System.Windows.Visibility.Collapsed;
            }
            else
            {
                m_assistantDisabledBtn.Visibility = System.Windows.Visibility.Visible;        
            }
        }
    }
}